unit main;
{
This file contains a sample CGI script that shows how to use the CGI component.
This program demonstrates a simple hit counter and would be called from
your HTML in the form of:

<img src="cgi-bin/counter.exe?INC=X">

where cgi-bin is your server's CGI-BIN directory. and X is the number
you want the hit count to be incremented by }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, cgicomp,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
 uses math;
{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
  {End the application}
  close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 F: file;
 CGI: TCGI;
 Hits: Longint;
 I, INC: Integer;
 Bitmaps: array[0..9] of TBitmap;
 ToSend, ToPaint: TBitmap;
 S: String;
begin
 CGI:=TCGI.Create(application);    //Create the component
 {First lets update the data file that will store the numnber of hits}
 AssignFile(F, CGI.CGIDIR + 'COUNTER.DAT'); //The component has a property CGI-DIR which holds the application directory
 If FileExists(CGI.CGIDIR + 'COUNTER.DAT') then reset(f,1) else ReWrite(f,1);

 {Get the value of INC variable, the number the user wants the counter incremented by}
 S:=CGI.GetFirstValue('INC');
 If S = '' then S:='1'; //Default is 1
 Inc:=StrToInt(S);

 If FileSize(F) = 0 then Hits:=1 else
 begin
  BlockRead(F, Hits, 4);         //Read current number
  Hits:=Hits + Inc;              //Increment counter
 end;
 Seek(F, 0);
 BlockWrite(F, Hits, 4);         //write the new number of hits
 CloseFile(F);                   //close the data file

 {Now we have the number of hits and we need to output this as an image}
 {First lets read in the bitmaps 0.gif - 9.gif which contain each digit}

 For I:=0 to 9 do
 begin
  Bitmaps[I]:=TBitmap.Create;
  Bitmaps[i].LoadFromFile(CGI.CGIDIR + IntToStr(I) + '.BMP');
 end;

 ToSend:=TBitmap.Create;

 {Calculate the required size of the output image}

 ToSend.Height:=Bitmaps[0].Height;     //height is constant regardless of number of hits
 ToSend.Width:=(Bitmaps[0].Width * Trunc(Log10(Hits)+1));

 S:=IntToStr(Hits);                    //Its easier to deal with a string as we want to look at each digit
 For I:=1 to length(S) do
 begin
  ToPaint:=Bitmaps[StrToInt(S[i])];    //Get the appropiate digit
  ToSend.Canvas.CopyRect(Rect(ToPaint.Width*(I-1), 0,((I-1)*ToPaint.Width) + ToPaint.Width , ToPaint.height), ToPaint.Canvas,
  Rect(0,0,ToPaint.WIdth, ToPaint.Height));        //Paint the digit onto the output bitmap
 end;

 {We are now ready to send the output image}

 {Set the content type. Even though we have a TBitmap to send the content type is
 still ctGifImage. The component performs the required conversion routine}

 CGI.ContentType:=ctGifImage;
 CGI.StartSend;     //Never forget this!

 CGI.SendImage(ToSend); //This sends the bitmap to the browser

 {Free up resources}
 For I:=0 to 9 do
   Bitmaps[I].Free;
 ToSend.Free;
 {The program ends when the form is shown becuase of the close statement in
 the FormShow event. The output is then sent to the browser.  }

end;

end.
